#!/usr/bin/env groovy

import groovy.sql.Sql;
import org.xdai.apprun.ApprunClient;
import java.io.*;

//-----getopt
def prompt='''./mysql2sqlite.groovy -b PathOfThisProgram
''';
def cli = new CliBuilder(usage: prompt);
cli.h(longOpt: 'help', 'print help information');
cli.b(longOpt: 'base', 'Base path of pipeline', args: 1);

def opt = cli.parse(args);
if(args.length<2||!opt||opt.h) { cli.usage(); System.exit(-1); }
def base;   if(opt.b) base=opt.b;      if(base==null)   { println 'Please set -b'; System.exit(-1); }

//---connect MySQL
def dboption=["host":"localhost",  "db":"PlantTFcat",  "user":"root",  "passwd":"",   "driver":"com.mysql.jdbc.Driver"];
def sql1 = Sql.newInstance("jdbc:mysql://${dboption.host}/${dboption.db}", dboption.user, dboption.passwd, dboption.driver);

//----connect SQLite
def dbfile="${base}/../data/families.sqlite";
new File(dbfile).delete();
def sql2 = Sql.newInstance("jdbc:sqlite:${dbfile}", "org.sqlite.JDBC");
sql2.execute("PRAGMA journal_mode=OFF");
sql2.execute("PRAGMA synchronous=OFF");
sql2.execute("BEGIN TRANSACTION");
sql2.execute("create table tffamily (family_acc text key, plant_specific text, family_type text, functional_domain text, family_type_desc text, acc_in_PlantTFDB text, rel_with_PlantTFDB text, acc_in_PlnTFDB text, rel_with_PlnTFDB text,new_in_PlantTFcat text, general_desc text, general_reference text, IPRs text, desc_for_IPRs text, Must_Have_Domain text, Should_Not_Have_Domain text)");

sql1.eachRow("select * from tffamily", {
     sql2.execute("insert into tffamily values (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)", [it.family_acc, it.plant_specific, it.family_type, it.functional_domain, it.family_type_desc, it.acc_in_PlantTFDB, it.rel_with_PlantTFDB, it.acc_in_PlnTFDB, it.rel_with_PlnTFDB, it.new_in_PlantTFcat, it.general_desc, it.general_reference, it.IPRs, it.desc_for_IPRs, it.Must_Have_Domain, it.Should_Not_Have_Domain]);
});

sql2.execute("COMMIT"); 
sql2.close();
sql1.close();
