#!/usr/bin/perl
use strict;

[%env]

my $args="[%argsline]";

# redirect files for stdin, stdout, stderr and exit code
my $stdin    = "[%stdin]";
my $stdout   = "[%stdout]";
my $stderr   = "[%stderr]";
my $exitcode = "[%exitcode]";

if ($stderr) {
    unless (open(STDERR, "> $stderr")) {
	print STDERR "ERROR [%binary] failed to redirect STDERR to $stderr: $!\n";
	exit 1;
    }
}

if ($stdout) {
    unless (open(STDOUT, "> $stdout")) {
	print STDERR "ERROR [%binary] failed to redirect STDOUT to $stdout: $!\n";
	exit 1;
    }
}

if ($stdin) {
    unless (open(STDIN, "< $stdin")) {
	print STDERR "ERROR [%binary] failed to redirect STDIN to $stdin: $!\n";
	exit 1;
    }
}

my $rc = 0xffff & system("[%binary] $args");

if ($exitcode) {
    unless (open(EXITCODE, "> $exitcode")) {
	print STDERR "ERROR [%binary] failed to write exit code to $exitcode: $!\n";
	exit 1;
    }
    print EXITCODE $rc;
    close(EXITCODE);
}

exit 0;

