#!/usr/bin/perl

# Script to wrap SGE's qstat command so that
# it returns something sensible that can be read
# by the Dispatcher etc.

#job-ID  prior   name       user         state submit/start at     queue                          slots ja-task-ID 
#-----------------------------------------------------------------------------------------------------------------
#  13082 0.56000 sleep.csh  hunter       r     07/04/2005 09:51:05 all                                1        
#
#################################################################################
# --  FINISHED JOBS  -  FINISHED JOBS  -  FINISHED JOBS  -  FINISHED JOBS  --  
#################################################################################
#  12982 0.00000 sleep.csh  hunter       qw    07/01/2005 11:18:10                                    1        
#  12983 0.00000 sleep.csh  hunter       qw    07/01/2005 11:18:39                                    1        
#  12984 0.00000 sleep.csh  hunter       qw    07/01/2005 11:19:11                                    1        
#  12985 0.00000 sleep.csh  hunter       qw    07/01/2005 11:19:28                                    1        
#  12986 0.00000 sleep.csh  hunter       qw    07/01/2005 11:19:28                                    1        
#

# get job number for SGE system
$jobid=shift;

#check qstat
$qstat = `qstat -f -s prszh`;
@qstat = split (/\n/,$qstat);

$finished = 0;
$notthere = 1;

foreach (@qstat) {
	if (/FINISHED/) {
		$finished = 1;
	}

	if($finished == 1 && /(.*\s+)qw(\s+\d+.*)/) {
		$line = "$1DONE$2";
	} else {
		$line = $_;
	}

	if ($line=~/^\s*$jobid\s/) {
		print $line."\n";
		$notthere=0;
		exit 0;
	} 
}

if ($notthere == 1) {
	print "\t$jobid\tiprscan\tw\t1234\n";
}
exit 0;

